Imports System
Imports DotNetNuke.Entities.Modules
Imports DotNetNuke.Entities.Modules.Actions
Imports DotNetNuke.Services.Exceptions
Imports DotNetNuke.Services.Localization

Namespace EfficionConsulting.Categories

    Public MustInherit Class Category
        Inherits PortalModuleBase
        Implements IActionable

        Private _DisplayAsLink As Boolean
        Private _LinkPage As String
        Private _FilterByParentCategory As Integer = -1

        Public Property DisplayAsLink() As Boolean
            Get
                Return _DisplayAsLink
            End Get
            Set(ByVal Value As Boolean)
                _DisplayAsLink = Value
            End Set
        End Property

        Public Property LinkPage() As String
            Get
                Return _LinkPage
            End Get
            Set(ByVal Value As String)
                _LinkPage = Value
            End Set
        End Property

        Public Property FilterByParentCategory() As Integer
            Get
                Return _FilterByParentCategory
            End Get
            Set(ByVal Value As Integer)
                _FilterByParentCategory = Value
            End Set
        End Property

        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            'TODO: Make Category List template driven
            DisplayAsLink = True 'TODO: Pull this from settings
            BindData()
        End Sub

        Sub BindData()
            Try
                Dim objCategories As New CategoryController
                If FilterByParentCategory <> -1 Then
                    lstCategories.DataSource = objCategories.GetCategoriesByParentID(PortalId, FilterByParentCategory)
                Else
                    lstCategories.DataSource = objCategories.GetCategories(PortalId)
                End If
                lstCategories.DataBind()
            Catch ex As Exception
                ProcessModuleLoadException(Me, ex)
            End Try
        End Sub

#Region "Optional Interfaces"

        Public ReadOnly Property ModuleActions() As Actions.ModuleActionCollection Implements IActionable.ModuleActions
            Get
                Dim Actions As New Actions.ModuleActionCollection
                Actions.Add(GetNextActionID, Localization.GetString(ModuleActionType.AddContent, LocalResourceFile), ModuleActionType.AddContent, "", "", EditUrl(), False, DotNetNuke.Security.SecurityAccessLevel.Edit, True, False)
                Return Actions
            End Get
        End Property

#End Region

#Region " Web Form Designer Generated Code "

        'This call is required by the Web Form Designer.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub

        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()

        End Sub

#End Region

    End Class
End Namespace
